<?php
/**
 * @ H2N Link Directory 1.0.0 admin.cpanel.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.cpanel.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 *
 * @ $Id: admin.cpanel.php,v 1.13 2008/10/10 22:01:30 harry Exp $
 *
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

class ExtentionManager{

	/**
	 * Ermittellt, ob ein Modul installiert ist und ob es veröffentlicht ist.
	 *
	 * @param string $name Name des Modul, Beispiel: mod_ld_dtree
	 * @return HTML mit dem Text, ob Modul installiert, veröffentlicht oder 
	 * nicht installiert ist.
	 */
	function checkModule($name){
		global $database;
		$found=false;
		$query="select * from #__modules";
		$database->setQuery( $query );
		$modules = $database->loadObjectList();
		foreach( $modules AS $module){
			if ($module->module == $name) {
				if ($module->published)
				return '<font color="green">'._LD_INSTALLED.'</font>';
				else
				return '<font color="yellow">'._LD_INSTALLED.'</font>';
			}
		}
		return  '<font color="red">'._LD_NOTINSTALLED.'</font>';
	}

	/**
	 * Ermittellt, ob ein Mambot/Plugin installiert ist und ob es veröffentlicht ist.
	 *
	 * @param string $name Name (element) des Mambot/Plugin, Beispiel: linkdirectory.searchbot
	 * @return HTML mit dem Text, ob Mambot/Plugin installiert, veröffentlicht oder 
	 * nicht installiert ist.
	 */
	function checkPlugin($name){
		global $database;
		if( defined('_JEXEC') ){
			$query="select * from #__plugins";
		}else {
			$query="select * from #__mambots";
		}
		$database->setQuery( $query );
		$plugins = $database->loadObjectList();
		foreach( $plugins AS $plugin){
			if ($plugin->element == $name) {
				if ($plugin->published)
				return '<font color="green">'._LD_INSTALLED.'</font>';
				else
				return '<font color="yellow">'._LD_INSTALLED.'</font>';
			}
		}
		return  '<font color="red">'._LD_NOTINSTALLED.'</font>';
	}
}

class StatisticManager{
	/**
	 * Ermittelt, wieviel Zeilen in $table enthalten sind.
	 * Bei published = 1 werdeb nur die Zeilen gezählt, dess 
	 * Feld published auf 1 ist, analoges published = 0;
	 *
	 * @param string $table Tabelle, aus der die Werte ermittelt werden soll
	 * @param $published bei 1 bzw 0 nur die Zeilen zählen, deren Feld published 
	 * gleich 1 bzw. 0 sind, bei NULL werden alle Zeilen gezählt. 
	 * @return Anzahl Zeilen
	 */
	function getInfo($table,$published=null){
		switch ($table) {
			case '#__ldcats':
			case '#__ldlinks':
			case '#__ldcomment':
				global $database;
				$query='SELECT count(*) FROM ' . $table;
				switch ($published) {
					case '1':
					case '0':
						if ($table=='#__ldcomment')
						$query.=' WHERE rev_approved=\''.$published.'\'';
						else
						$query.=' WHERE published=\''.$published.'\'';
						break;
				}
				$database->setQuery($query);
				return $database->loadResult();
		}
		return -1;
	}
}

class VersionManager {
	/**
	 * Ermittelt die lokal vorliegende Version vom Link Directory
	 *
	 * @return lokal vorliegende Version vom Link Directory
	 */
	function getLocalVersion(){
		global $mosConfig_absolute_path,$ld;
		require_once( $mosConfig_absolute_path .'/includes/domit/xml_domit_lite_include.php' );
		$modInstallFile = $mosConfig_absolute_path. '/administrator/components/com_linkdirectory/linkdirectory.xml';
		if( defined('_JEXEC') ){
			$installFile = JApplicationHelper::parseXMLInstallFile($modInstallFile);
			return $installFile['version'];
		} else {
			$xmlDoc = new DOMIT_Lite_Document();
			$xmlDoc->resolveErrors( true );
			if (!$xmlDoc->loadXML( $modInstallFile, false, true )) {
				return _LD_UNKNOWN;
			}
			$root = &$xmlDoc->documentElement;
			if ($root->getTagName() != 'mosinstall') {
				return _LD_UNKNOWN;
			}
			if ($root->getAttribute('type') != 'component') {
				return _LD_UNKNOWN;
			}
			$element 	= &$root->getElementsByPath('version', 1);
			$snrver 	= $element ? $element->getText() : '';
			return $snrver;
		}
	}

	function getCurrentVersion($checkversion){
		$handle=NULL;
		if ($checkversion) {
			$filename = "http://www.joomla-hklein.de/linkdirectory.php";
			$handle = @fopen($filename, "r");
		}
		if (!$handle) {
			$currentver = _LD_UNKNOWN;
		} else {
			$currentver = fread($handle, 7);
			fclose($handle);
		}
		return $currentver;
	}

	function compareVersion($currentver,$snrver){
		if ($currentver == _LD_UNKNOWN) {
			$updateAvailableAsHTML = "";
		} else if ($currentver > $snrver) {
			$updateAvailableAsHTML = "<a href=\"http://www.joomla-hklein.de\" target=\"_blank\">". _LD_UPGRADE ."</a>";
		} else {
			$updateAvailableAsHTML = _LD_UPTODATE;
		}
		return $updateAvailableAsHTML;
	}
}

function CPanel() {
	global $ld,$option;
	//Webcat Info
	$total['cats'] = StatisticManager::getInfo('#__ldcats');
	$total['pcats'] = StatisticManager::getInfo('#__ldcats',1);
	$total['acats'] = StatisticManager::getInfo('#__ldcats',0);

	//Weblink Info
	$total['links'] = StatisticManager::getInfo('#__ldlinks');
	$total['plinks'] = StatisticManager::getInfo('#__ldlinks',1);
	$total['alinks'] = StatisticManager::getInfo('#__ldlinks',0);

	//Comment Info
	$total['comments'] = StatisticManager::getInfo('#__ldcomment');
	$total['pcomments'] = StatisticManager::getInfo('#__ldcomment',1);
	$total['acomments'] = StatisticManager::getInfo('#__ldcomment',0);

	//Mambot Check
	$mambot['rlinks'] = ExtentionManager::checkPlugin('linkdirectory.rlinks');
	$mambot['search'] = ExtentionManager::checkPlugin('linkdirectory.searchbot');

	//Modul Check
	$modules['ld_stats'] = ExtentionManager::checkModule('mod_ld_stats');
	$modules['ld_latest'] = ExtentionManager::checkModule('mod_ld_latest');
	$modules['ld_popular'] = ExtentionManager::checkModule('mod_ld_popular');
	$modules['ld_dtree'] = ExtentionManager::checkModule('mod_ld_dtree');
	$modules['ld_hitlists'] = ExtentionManager::checkModule('mod_ld_hitlists');

	$snrver=VersionManager::getLocalVersion();
	$currentver=VersionManager::getCurrentVersion((bool)$ld->versioncheck);
	$updateAvailableAsHTML=VersionManager::compareVersion($currentver,$snrver);
	Cpanel_HTML::CPanel( $currentver, $snrver, $total, $updateAvailableAsHTML, $modules, $mambot,$option );
}
?>
