<?php
/**
 * @ H2N Link Directory 1.0.0 admin.importexport.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 admin.importexport.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

function ExportLinks() {

	$options = array();
	$options[] = mosHTML::makeOption('0', _LD_ALL_CATEGORIES );
	$lists['parent'] = categoryParentList(NULL, "", $options);

	exportimport_html::export($lists);
}

function exportLink($option) {
	$catid = mosGetParam( $_POST, 'parent_id', array(0) );
	header( "Location: components/com_linkdirectory/export.class.php?option=com_linkdirectory&catid=$catid" );
}

function ImportLinks() {
	global $database;
	$options = array();
	$options[] = mosHTML::makeOption('-1', _SEL_CATEGORY );
	$lists['parent'] = categoryParentList(NULL, "", $options);

	$database->setQuery( "SELECT id AS value, name AS text FROM #__groups ORDER BY id" );
	$groups = $database->loadObjectList();
	$lists['group'] = mosHTML::selectList( $groups, 'access', 'class="inputbox" size="1"', 'value', 'text', 0 );

	exportimport_html::import($lists);
}


function ImportLink($option, $parent_id, $access) {
	global $database, $my;

	echo '<div align="left">'."\n";

	if (!file($_FILES['importfile']['tmp_name'])) {
		importWeblinks( $option, $parent_id, $access );
		return;
	}

	$lines = file($_FILES['importfile']['tmp_name']);
	$catid = mosGetParam( $_POST, 'parent_id', array(0) );
	$access = mosGetParam( $_POST, 'access', array(0) );
	$parentcatrow = new snrCats( $database );
	$parentcatrow->load($catid);

	$folders = 0;
	$ldbookmarks = 0;
	$ldcategories = 0;
	$ldlines = 0;
	$parent_stack = array(&$parentcatrow);

	echo "<h3>". _LD_IMPORTING_FILE_LINKS ."</h3><br />";

	foreach ($lines as $line) {

		if (stristr($line, '<DT><H3') !== false) {

			$ldcategories++;
			$new_cat = trim(strip_tags($line));

			for ($i=0;$i<count($parent_stack)-1;$i++) {
				echo "..";
			}
			echo "<b>"._LD_CAT."</b> : [$ldcategories] <b>$new_cat</b><br />\n";

			// *** Start of a category. (add a subcat to a parent)
			$parent = &$parent_stack[count($parent_stack) - 1];
			if ( (count($parent_stack)) && ($parent->name != "")) {
				$name = $new_cat;
			} else {
				$name = $new_cat;
			}

			// *** load the row from the db table
			$category = new snrCats( $database );
			$category->loadByName( $name );

			// *** Import also Description !!! "<dd>" tag
			if (strpos($lines[$ldlines+1], '<DD>') !== false) {  // found a description on next line...
				$catdesc = trim(strip_tags($lines[$ldlines+1]));
				echo "<i>"._LD_DESC."</i> : ".$catdesc."<br />\n";
			} else {
				$catdesc = "";
			}

			// *** Create new category if it doesn't exist.
			if ( !$category->id ) {
				// *** Create category

				// !!! WORKAROUND : Manual ID incrementation for new Cat, as "auto_increment" is disabled due to not allowing negative value as ID !!!
				$database->setQuery( "SELECT MAX(id) AS maxid FROM #__ldcats" );
				$maxid = $database->loadResult();
				if ($maxid == -1) {
					$category->id = 1;  // only Root Cat (ID = -1) => Next ID is "1" not "0"...
				} else {
					$category->id = $maxid+1;
				}

				// !!! WORKAROUND : Need to create an empty Record as "store()" use "UPDATE" as ID is not "0" (0 for new Cat) so record must exists for other IDs !!!
				$database->setQuery( "INSERT INTO #__ldcats (id) VALUES (".$category->id.")" );
				if (!$database->query()) {
					echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
					exit;
				}

				$category->title = $new_cat;
				$category->name = $name;
				if ($parent->name != "") {
					$category->parent_id = $parent->id;
				} else {
					$category->parent_id = 0;  // Root Cat (ID = -1)
				}
				$category->access = $access;
				$category->editor = $my->id;
				$category->published = 1;
				$category->description = $catdesc;

				$category->store();

				$category->checkin();
			}

			array_push($parent_stack, $category);   // Add subcat to parent stack

		} elseif (strstr($line, '</DL>') !== false) {               // *** End of a category.

			array_pop($parent_stack);

		} elseif (preg_match("/<DT><A HREF=\"*(.*?)\".*>(.*)<\/A>/", $line, $temp)) {   // *** Add Bookmark item

			$ldbookmarks++;
			$parent = &$parent_stack[count($parent_stack) - 1];

			for ($i=0;$i<count($parent_stack) - 1;$i++) { echo ".."; }
			echo ".."._LD_LINK." : [$ldcategories:$ldbookmarks] <b>".trim($temp[2])."</b><br />\n";

			$bookmark = new snrLinks( $database );
			$bookmark->catid = $parent->id;
			$bookmark->title = trim($temp[2]);
			$bookmark->url = trim($temp[1]);
			$bookmark->published = 0;
			$bookmark->hits = 0;
			$bookmark->created = date( "Y-m-d H:i:s" );

			 
			// *** Import also Description !!! "<DD>" tag
			if (strpos($lines[$ldlines+1], '<DD>') !== false) {  // found a description on next line...
				$bookmark->description = trim(strip_tags($lines[$ldlines+1]));
				echo _LD_DESC." : ".$bookmark->description."<br />\n";
			} else {
				$bookmark->description = "";
			}

			if (!$bookmark->store()) {
				echo "<script type='text/javascript'> alert('".$bookmark->getError()."'); window.history.go(-1);</script>\n";
				exit;
			}
			$bookmark->checkin();

		}

		$ldlines++;

	}

	echo "<br /><b>".$ldcategories."</b> "._LD_CAT_AND." <b>".$ldbookmarks."</b> "._LD_LINK_IMPORT."<br />\n";

	echo '</div>';

	echo '<br />';
	echo '<span class="back_button"><a href="index2.php?option='.$option.'&task=import"><b>'._LD_BACK.'</b></a></span>';

	//    mosRedirect( "index2.php?option=$option" );
}

function importWeblinks( $option, $parent_id, $access ) {
	global $database, $my;

	echo '<div align="left">';

	$catid = mosGetParam( $_POST, 'parent_id', array(0) );
	$access = mosGetParam( $_POST, 'access', array(0) );
	$parentcatrow = new snrCats( $database );
	$parentcatrow->load($catid);

	$folders = 0;
	$ldbookmarks = 0;
	$ldcategories = 0;
	$parent_stack = array(&$parentcatrow);

	echo "<h3>"._LD_IMPORTING_COMP_LINKS."</h3><br />";

	$database->setQuery( "SELECT w.*, c.name as catname"
	. "\n FROM #__weblinks as w"
	. "\n LEFT JOIN #__categories as c ON c.id = w.catid"
	. "\n ORDER BY c.name, w.title"
	);
	$links = $database->loadObjectList();

	$prevcat = "";

	foreach ($links as $link) {

		if ($link->catname != $prevcat) {  // this is a New Cat => Add Cat

			$ldcategories++;

			// *** End of a category.
			if ($prevcat != "") {  // remove subcat from parent stack
				array_pop($parent_stack);
			}

			$cat = new mosCategory( $database );
			$cat->load($link->catid);

			$new_cat = $cat->title;

			// *** Start of a category (add a subcat to a parent).
			$parent = &$parent_stack[count($parent_stack) - 1];
			if ( (count($parent_stack)) && ($parent->name != "")) {
				$name = $new_cat;
			} else {
				$name = $new_cat;
			}

			for ($i=0;$i<count($parent_stack)-1;$i++) {
				echo "..";
			}
			echo "<b>"._LD_CAT."</b> : [$ldcategories] <b>$new_cat</b><br />\n";

			// *** Load the row from the db table
			$row = new snrCats( $database );
			$row->loadByName( $name );

			// *** Create new category if it doesn't exist.
			if ( !$row->id ) {
				// *** Create category

				// !!! WORKAROUND : Manual ID incrementation for new Cat, as "auto_increment" is disabled due to not allowing negative value as ID !!!
				$database->setQuery( "SELECT MAX(id) AS maxid FROM #__ldcats" );
				$maxid = $database->loadResult();
				if ($maxid == -1) {
					$row->id = 1;  // only Root Cat (ID = -1) => Next ID is "1" not "0"...
				} else {
					$row->id = $maxid+1;
				}

				// !!! WORKAROUND : Need to create an empty Record as "store()" use "UPDATE" as ID is not "0" (0 for new Cat) so record must exists for other IDs !!!
				$database->setQuery( "INSERT INTO #__ldcats (id) VALUES (".$row->id.")" );
				if (!$database->query()) {
					echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
					exit;
				}

				$row->title = $new_cat;
				$row->name = $name;
				if ($parent->name != "") {
					$row->parent_id = $parent->id;
				} else {
					$row->parent_id = 0;  // Parent = Root Cat (ID = 0)
				}
				$row->published = $cat->published;
				$row->image = $cat->image;
				$row->description = $cat->description;
				$row->checked_out = $cat->checked_out;
				$row->checked_out_time = $cat->checked_out_time;
				$row->access = $access;
				$row->editor = $my->id;

				$row->store();

				$row->checkin();
			}

			array_push($parent_stack, $row);  // Add subcat to parent stack

			$prevcat = $link->catname;

		}

		// *** Create Bookmark
		$parent = &$parent_stack[count($parent_stack) - 1];  // Get cat from parent stack

		$ldbookmarks++;

		for ($i=0;$i<count($parent_stack) - 1;$i++) { echo ".."; }
		echo ".."._LD_LINK." : [$ldcategories:$ldbookmarks] <b>".htmlspecialchars($link->title, ENT_NOQUOTES)."</b><br />\n";

		$bookmark = new snrLinks( $database );
		$bookmark->title = $link->title;
		$bookmark->catid = $parent->id;
		$bookmark->url = $link->url;
		$bookmark->description = $link->description;
		$bookmark->published = $link->published;
		$bookmark->created = $link->date;
		$bookmark->hits = $link->hits;
		$bookmark->checked_out = $link->checked_out;
		$bookmark->checked_out_time = $link->checked_out_time;

		if (!$bookmark->store()) {
			echo "<script type='text/javascript'> alert('".$bookmark->getError()."'); window.history.go(-1);</script>\n";
			exit;
		}
		$bookmark->checkin();

	}  // *** Next link

	echo "<br /><b>".$ldcategories."</b> "._LD_CAT_AND." <b>".$ldbookmarks."</b> "._LD_LINK_IMPORT."<br />\n";

	echo '</div>';

	echo '<br />';
	echo '<span class="back_button"><a href="index2.php?option='.$option.'&task=import"><b>'._LD_BACK.'</b></a></span>';

}
?>