<?php
/**
 * @ H2N Link Directory 1.0.0 linkdirectory.class.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ Link Directory 1.1 linkdirectory.class.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

class snrLinks extends mosDBTable {

	var $id = null;

	var $catid = null;

	var $title = null;

	var $url = null;

	var $description = null;

	var $created = null;

	var $modified = null;

	var $hits = null;

	var $rating = null;

	var $votes = null;

	var $published = null;

	var $checked_out = null;

	var $checked_out_time = null;

	var $ordering = null;

	var $params = null;
	
	var $description_long = null;

	function snrLinks( &$db ) {
		$this->mosDBTable( '#__ldlinks', 'id', $db );
	}

	function check() {
		// filter malicious code
		$ignoreList = array( 'params','description_long' );
		$this->filter( $ignoreList );

		// specific filters
		if( defined('_JEXEC') ){
			include_once(_LD_ABSOLUTE_PATH . '/libraries/phpinputfilter/inputfilter.php');
		}
		$iFilter = new InputFilter();

		if ($iFilter->badAttributeValue( array( 'href', $this->url ))) {
			$this->_error = _LD_VALIDURL;
			return false;
		}

		/** check for valid name */
		if (trim( $this->title ) == '') {
			$this->_error = _LD_WEBLINK_NAME;
			return false;
		}

		/** check for valid category */
		if ((trim( $this->catid ) == '') || (trim( $this->catid ) == '0')) {
			$this->_error = _LD_WEBLINK_CAT;
			return false;
		}

		/** check for valid url */
		if ((trim( $this->url ) == '') || (trim( $this->url ) == '0')) {
			$this->_error = _LD_VALIDURL;
			return false;
		}

		if ( !( eregi( 'http://', $this->url ) || ( eregi( 'https://',$this->url ) )  || ( eregi( 'ftp://',$this->url ) ) ) ) {
			$this->url = 'http://'.$this->url;
		}

		/** check for existing name */
		$query = "SELECT id"
		. "\n FROM #__ldlinks "
		. "\n WHERE title = '$this->title'"
		. "\n AND catid = $this->catid"
		;
		$this->_db->setQuery( $query );

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _WEBLINK_EXIST;
			return false;
		}
		return true;
	}

}

class snrCats extends mosDBTable {


	var $id = null;

	var $parent_id = null;

	var $title = null;

	var $name = null;

	var $image = null;

	var $description = null;

	var $published = null;

	var $checked_out = null;

	var $checked_out_time = null;

	var $editor = null;

	var $ordering = null;

	var $access = null;

	var $count = null;

	var $params = null;


	function snrCats( &$db ) {
		$this->mosDBTable( '#__ldcats', 'id', $db );
	}

	function loadByName( $name ) {
		$this->_db->setQuery( "SELECT * FROM #__ldcats WHERE name=$name" );
		return $this->_db->loadObject( $this );
	}
	
	function check() {
		// filter malicious code
		$ignoreList = array( 'params','description' );
		$this->filter( $ignoreList );

		/** check for valid title */
		if (trim( $this->title ) == '') {
			$this->_error = _LD_CAT_HAVEATITLE;
			return false;
		}
		
		/** check for valid name */
		if (trim( $this->name ) == '') {
			$this->_error = _LD_HAVEANAME;
			return false;
		}

		/** check for existing name or title */
		$query = "SELECT id"
		. "\n FROM #__ldcats "
		. "\n WHERE ( title = '$this->title'"
		. "\n OR name = '$this->name' )"
		. "\n AND parent_id	 = $this->parent_id"
		;
		$this->_db->setQuery( $query );
		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = _LD_CAT_EXIST;
			return false;
		}
		
		return true;
	}
}

class snrComments extends mosDBTable {

	var $rev_id = null;

	var $link_id = null;

	var $user_id = null;

	var $type = null;
	
	var $guest_name = null;

	var $rev_title = null;

	var $rev_text = null;

	var $rev_date = null;

	var $rev_approved = null;
	
	var $published = null;

	var $checked_out = null;

	var $checked_out_time = null;

	function snrComments( &$db ) {
		$this->mosDBTable( '#__ldcomment', 'rev_id', $db );
	}

}

class snrLog extends mosDBTable {

	var $log_ip = null;

	var $log_type = null;

	var $user_id = null;

	var $log_date = null;

	var $link_id = null;


	function snrLog( &$db ) {
		$this->mosDBTable( '#__ldlog', 'log_ip', $db );
	}

}

//Link Directory ACO GROUPS - not work now...
class snrGroups extends mosDBTable {

	var $groups_id = null;

	var $groups_name = null;

	var $groups_description = null;

	var $groups_access = null;

	var $groups_members = null;

	function snrGroups( &$db ) {
		$this->mosDBTable( '#__ldgroups', 'groups_id', $db );
	}
}
?>