<?php
/**
 * @ H2N Link Directory 1.0.0 linkdirectory.linkthumbnail.php
 * @ Copyright (C) 2008 Harry Klein - www.joomla-hklein.de
 * @
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 * @
 * @ $Id: linkdirectory.linkthumbnail.php,v 1.2 2008/10/09 21:23:47 harry Exp $
 * @
 **/


function getAllSupportedLinkThumbnailServices(){
	return array('thumbshots.de','livethumb.de','mr-thumb.de','artviper.net');
}


/**
 * Liefert den benötigen BackLink für den jeweiliegn Link-Thum-Dienst.
 *
 * @return String HTML mit dem jeweiligen Code für den Back-Link
 */
function getBackLinkForLinkThumb(){
	if (!isLinkThumbEnable())
	return '';
	global $ld;
	switch ($ld->linkthumbtype){
		case 'thumbshots.de':
			return '<a href="http://www.thumbshots.de/" target="_blank"><img height="16" alt="Kostenlose Screenshots Ihrer Webseite von Thumbshots.de" src="http://www.thumbshots.de/images/thumbshots_2007.png" width="80" border="0" /></a>';
		case 'livethumb.de':
			return '<a href="http://livethumb.de" target="_blank">liveThumb</a>';
		case 'mr-thumb.de':
			return '<a href="http://www.mr-thumb.de" target="_blank" title="Thumbshots von Mr-Thumb Free Thumbnail Service"><img border="0" src="http://www.mr-thumb.de/images/button.gif" width="80" height="15" alt="Mr-Thumb Free Thumbnail Service"></a>';
		case 'artviper.net':
			return '';
		case 'user':
			return $ld->linkthumbuserbacklinkhtml;
		case 'none';
		default:
			return '';
	}
}


/**
 * Liefert true, wenn ein Link-Thum-Dienst konfiguriert worden ist.
 *
 * @return true, wenn ein Link-Tumb-Dienst konfiguriert worden ist
 * @see $ld->linkthumbtype
 */
function isLinkThumbEnable(){
	global $ld;
	switch ($ld->linkthumbtype){
		case 'thumbshots.de':
		case 'livethumb.de':
		case 'mr-thumb.de':
		case 'thumber.de':
		case 'artviper.net':
		case 'user':
			return true;
		case 'none';
		default:
			return false;
	}
}


/**
 * Gibt das HTML zurück, welches für das holen des Tumb-Images benötig wird. Welcher 
 * Dienst dazu benutzt wird, legt die Variable
 * $ld->linkthumbtype fest.
 *
 * @param String $url URL,deren Thumb-Image angefordert werden soll.
 * @param String $title Titel der Url
 * @param int Id des Links
 * @return String mit dem HTML 0
 */
function getThumbForLink($url,$title,$id){
	if (!isLinkThumbEnable())
	return '';
	global $ld,$Itemid;
	$aHtml_1='<a href="'.getUrlToLink($url,$id,$Itemid).'" target="_blank">';
	$aHtml_2='</a>';
	switch ($ld->linkthumbtype){
		case 'thumbshots.de':
			return $aHtml_1.'<img src="http://www.thumbshots.de/cgi-bin/show.cgi?url='.$url.'" border="0" align="left" vspace="5" hspace="5" onload="if (this.width>50) this.border=1; this.alt=\'Vorschau bei Thumbshots.de\';">'.$aHtml_2;
		case 'livethumb.de':
			return $aHtml_1.'<img src="http://livethumb.de/?url='.$url.'&size=200" alt="'.$title.'" align="left" vspace="5" hspace="5" border="0" />'.$aHtml_2;
		case 'mr-thumb.de':
			return $aHtml_1.'<img src="http://www.mr-thumb.de/kunterbunt.php?url='.$url.'&size=200" align="left" vspace="5" hspace="5" border="0" />'.$aHtml_2;
		case 'artviper.net':
			return $aHtml_1.'<img src="http://www.artviper.net/screenshots/screener.php?url='.$url.'&w=160&h=120&sdx=1024&sdy=768&q=90" alt="'.$title.'" height="120" width="160" align="left" vspace="5" hspace="5" border="0" />'.$aHtml_2;
		case 'user':
			return $aHtml_1.sprintf($ld->linkthumbuserhtml,$url,$title).$aHtml_2;
		case 'none';
		default:
			return '';
	}
}


?>